{ RecentFiles-Komponente
  Komponente zur einfachen handhabung und speicherung
  der zuletzt geladenen Dateien in einer ini-datei.

  Version 1.0

  Freeware by jens Khner
              email: inu96117@sophos.adv-boeblingen.de
}
unit recentFiles;

interface

uses
  iniFiles, menus,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TOnItemClickEvent = procedure(sender:tobject; filename:string) of object;
  TRecentFiles = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
    fIniFileName:string;
    fMenuItem:TMenuItem;
    fmax:integer;
    fExistingFilesOnly:boolean;
    fOnItemClick:TOnItemClickEvent;
    procedure ItemClick(sender:tobject);
    procedure SetMenuItem(NewItem:TMenuItem);
  public
    { Public declarations }
    constructor create(AOwner:TComponent); override;
    destructor destroy; override;
    procedure addfile(newfile: string);
    procedure writetoIni;
    procedure readfromIni;
   published
    { Published declarations }
    property IniFileName:string read fIniFileName write fIniFileName;
    property Max:integer read fMax write fMax;
    property MenuItem:TMenuItem read fMenuItem write SetMenuItem;
    property OnItemClick:TOnItemClickEvent read fOnItemClick write fOnItemClick;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TRecentFiles]);
end;

constructor TRecentFiles.create(AOwner:TComponent);
begin
   inherited Create(AOwner);
   Max:=9;
   inifilename:='ini.ini';
end;

destructor TRecentFiles.destroy;
var i:integer;
begin
  if assigned(MenuItem) then
     for i:=0 to MenuItem.count-1 do
        MenuItem.items[0].free;
  inherited destroy;
end;

procedure TRecentFiles.AddFile(newfile: string);
var newItem:TMenuItem;
    index:integer;
    i:integer;
begin
   { maximal max eintrage }
   while MenuItem.Count>=Max do begin
      MenuItem.Delete(MenuItem.Count-1);
   end;
   newfile:=uppercase(newfile);
   index:=-1;
   for i:=0 to MenuItem.count-1 do begin
     if menuitem.items[i].caption=newfile then
       index:=i;
   end;
   { noch nicht drin }
   if index=-1 then begin
     newItem:=TMenuItem.Create(MenuItem);
     with newItem do begin
       caption:=newfile;
       OnClick:=ItemClick;
     end;
     MenuItem.insert(0,newItem);
   end
   else begin
     { an erste stelle }
     newitem:=MenuItem.items[index];
     MenuItem.delete(index);
     MenuItem.Insert(0,newitem);
   end;
end;

procedure TrecentFiles.SetMenuItem(NewItem:TMenuItem);
begin
  fmenuItem:=NewItem;
end;

procedure TRecentFiles.ReadFromIni;
var s:string;
    inifile:TiniFile;
    i:integer;
begin
   IniFile := TIniFile.create(ExtractFilePath(ParamStr(0))+ iniFileName);
   try
     { weil addfile an erste stelle addiert }
     for i:=max-1 downto 0 do begin
        s:=IniFile.ReadString('Recent Files', inttostr(i), '');
        if s<>'' then
          addfile(s);
     end;
   finally
     iniFile.free;
   end;
end;

procedure TrecentFiles.WriteToIni;
var s:string;
    inifile:TiniFile;
    i:integer;
begin
   IniFile := TIniFile.create(ExtractFilePath(ParamStr(0))+ iniFileName);
   try
     for i:=0 to menuitem.count-1 do begin
        s:=(MenuItem.Items[i] as TMenuItem).caption;
        IniFile.WriteString('Recent Files', inttostr(i), s);
     end;
   finally
     iniFile.free;
   end;
end;

procedure TrecentFiles.ItemClick(sender:tobject);
var newitem:tmenuitem;
begin
  newitem:=sender as TMenuItem;
  addfile(newitem.caption); { nach oben bringen}
  if assigned(fOnItemClick) then begin
      fOnItemClick(self, newitem.caption);
  end;
end;


end.
